/* access to the EV5 performance counters */


/* start of ev5 performance counters. Returns 0 on success, otherwise some
   error value.
   sel0-sel2 contain event selectors for counter0 - counter 2. For counter1
   and counter2, CBOX events are decoded as event selectors larger than 0x0e.
   The CBOX value is computed as (value - 0x0f).
*/
int
ev5_perfctr_start(
	       int *sel0,	       /* I: selector counter 0 */
	       int *sel1,	       /* I: selector counter 1 */
	       int *sel2,	       /* I: selector counter 2 */
	       unsigned int mode       /* I: mode bits (kernel,user) */
);


/* reads out performance counters of EV5.                                     */
/* Returns 0 if successful, otherwise some error value.                       */
int
ev5_perfctr_read(
		  long *ctr0,	       /* O: counter 0 */
		  long *ctr1,	       /* O: counter 1 */
		  long *ctr2	       /* O: counter 2 */
);


/* reads out performance counters of EV5 and stop counters.                   */
/* Returns 0 if successful, otherwise some error value.                       */
int
ev5_perfctr_stopread(
		  long *ctr0,	       /* O: counter 0 */
		  long *ctr1,	       /* O: counter 1 */
		  long *ctr2	       /* O: counter 2 */
);

/* read out the processor cycle counter (take care of overflow!) */
long
ev5_read_cycle_counter(void);
