C***********************************************************************
C***  simple test program for PCL

      PROGRAM PCL_test
C*** declarations
      IMPLICIT NONE
      INCLUDE 'pclh.f'
      INTEGER N
      PARAMETER(N=200)
      INTEGER counter_list(1), event, flags, res
      INTEGER*8 i_result
      REAL*8 fp_result
      INTEGER PCLquery, PCLstart, PCLstop
      EXTERNAL PCLquery, PCLstart, PCLstop
      EXTERNAL matadd
      REAL*8 a(N,N), b(N,N), c(N,N)

C*** count for user mode (on MIPS PCL_MODE_USER)
      flags = PCL_MODE_USER_SYSTEM
C***  loop over all defined event types
      DO event=0,PCL_MAX_EVENT-1

         counter_list(1) = event
C***     check if event is available
         res = PCLquery(counter_list, 1, flags)
         IF(res .EQ. PCL_SUCCESS) THEN

C***        start counting
            IF(PCLstart(counter_list, 1, flags) .NE. PCL_SUCCESS) THEN
               WRITE(*,*) 'problem with starting event ',event
            ENDIF

C***        do some work
            CALL matadd(a,b,c,n)

C***        stop counting
            res = PCLstop(i_result, fp_result, 1)
            IF(res .NE. PCL_SUCCESS) THEN
               WRITE(*,*) 'problem with stopping event ',event
            ELSE
               IF(event .LT. PCL_MFLOPS) THEN
C***              integer result
                  WRITE(*,*) 'event ', event, ': ', i_result
               ELSE
                  WRITE(*,*) 'event ', event, ': ', fp_result
               ENDIF
            ENDIF

         ELSE
C***        event not supported
            WRITE(*,*) 'event ', event, ' not supported (',res,')'
         ENDIF
      ENDDO

      STOP
      END

C***********************************************************************

      SUBROUTINE matadd(a,b,c,n)
      IMPLICIT NONE
      INTEGER N,i,j
      REAL*8 a(N,N), b(N,N), c(N,N)

      DO i=1,n
         DO j=1,n
            a(i,j) = b(i,j) * c(i,j)
         ENDDO
      ENDDO

      RETURN
      END

C***********************************************************************
