#include <stdio.h>
#include <fcntl.h>
#include "perfmon.h"

main()
{
    register unsigned long long a, b;
    unsigned long long tmp;
    unsigned long x, y;
    int fd, rc;
    register int i;

    fd = open("/dev/perfmon", O_RDONLY);
    if (fd == -1) {
	perror("open(/dev/perfmon)");
	exit(1);
    }

    a = get_tick();
    b = get_tick();
    printf("tick diff: %llx\n", b - a);

    tmp = PCR_USER_TRACE | PCR_S0_CYCLE_CNT | PCR_S1_INSTR_CNT;
    rc = ioctl(fd, PERFMON_SETPCR, &tmp);
    if (rc < 0)
	perror("ioctl()");

    /* Gather performance info on a test loop */
    cpu_sync();
    a = get_pic();
    for (i = 0; i < 10000; i++) {
	tmp += i;
    }
    cpu_sync();
    b = get_pic();

    /* Get the number of instructions executed */
    x = extract_pic1(b) - extract_pic1(a);

    /* Get the number of cycles that passed */
    y = extract_pic0(b) - extract_pic0(a);

    printf("Number of instructions executed: %lu\n", x);
    printf("Number of cycles used: %lu\n", y);
    printf("CPI = %.2lf\n", (double)y/(double)x);
}
